// ------------------------------------------------------------------------
// qeaudiotrap.cpp: Audio trap objects that can be inserted to a ecasound
//                  engine instance.
// Copyright (C) 2001 Kai Vehmanen (kaiv@wakkanet.fi)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
// ------------------------------------------------------------------------

#include <iostream>

#include "qevumeter.h"
#include "qeaudiotrap.h"

using std::cerr;
using std::endl;

QEAudioTrap::QEAudioTrap(QObject *parent, const char *name, QEVUMeter* target) 
{
  // initialize libecasound specific variables
  channels_rep = 0;
  sample_processing_step = 0;
  buffer_repp = 0;
  vumeter_target_repp = target;
}

QEAudioTrap::~QEAudioTrap(void) {
//    cerr << "qeaudiotrap desctructor" << endl;
}

void QEAudioTrap::init(SAMPLE_BUFFER *insample) { 
  buffer_repp = insample;
  channels_rep = insample->number_of_channels();
  sample_processing_step = insample->length_in_samples();
}

void QEAudioTrap::process(void) {
//    cerr << "process()" << endl;

  if (vumeter_target_repp != 0) 
    vumeter_target_repp->dataUpdated(buffer_repp);
}
